
Redmine - Defect #6196

undefined method `stringify_keys!' for #<Array:...>) when logging in, for some users only

2010-08-23 19:53 - mathew murphy

Status: Closed Start date: 2010-08-23

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Accounts / authentication Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version:  

Description

Processing AccountController#login (for 9.77.143.183 at 2010-08-23 12:31:54) [POST]               

                                                              

  Parameters: {"back_url"=>"[CORRECT MAIN SITE URL, FILTERED]", "action"=>"login", "authenticity_t

oken"=>"vXoesYJBWVTEeKS5gpOL2mQZbsrbi4yNj0WaXcnKYh0=", "username"=>"[CORRECT USERNAME, FILTERED]",

 "controller"=>"account", "password"=>"[FILTERED]", "login"=>"Login »"}                           

                             

NoMethodError (undefined method `stringify_keys!' for #<Array:0xb511a87c>):     

  app/models/user.rb:118:in `new'                                               

  app/models/user.rb:118:in `try_to_login'                                      

  app/controllers/account_controller.rb:147:in `password_authentication'        

  app/controllers/account_controller.rb:142:in `authenticate_user'              

  app/controllers/account_controller.rb:30:in `login'                           

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/rack/request_handler.rb:81:in `proc

ess_request'                                                  

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_request_handler.rb:203:in 

`main_loop'                                                   

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/railz/application_spawner.rb:340:in

 `start_request_handler'                                      

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/railz/application_spawner.rb:298:in

 `handle_spawn_application'                                   

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/utils.rb:181:in `safe_fork'        

                                                              

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/railz/application_spawner.rb:296:in

 `handle_spawn_application'                                   

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:337:in `__send__

'                                                             

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:337:in `main_loo

p'                                                            

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:187:in `start_sy

nchronously'                                                  

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:154:in `start'  

                                                              

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/railz/application_spawner.rb:192:in

 `start'                                                      

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/spawn_manager.rb:257:in `spawn_rail

s_application'                                                

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server_collection.rb:126:i

n `lookup_or_add'                                             

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/spawn_manager.rb:251:in `spawn_rail

s_application'                                                

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server_collection.rb:80:in

 `synchronize'                                                

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server_collection.rb:79:in

 `synchronize'                                                

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/spawn_manager.rb:250:in `spawn_rail

s_application'                                                

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/spawn_manager.rb:153:in `spawn_appl

ication'                                                      

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/spawn_manager.rb:282:in `handle_spa

wn_application'                                               
  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:337:in `__send__

'                                                             

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:337:in `main_loo

p'                                                            

  /var/lib/gems/1.8/gems/passenger-2.2.2/lib/phusion_passenger/abstract_server.rb:187:in `start_sy

nchronously'     

 Weirdly, it works fine for me, but it fails for some other people.

RedMine 1.0.1

ruby 1.8.6 (2007-09-24 patchlevel 111)

Rails 2.3.8

PostgreSQL 8.2.7

Ubuntu 8.10

History

#1 - 2010-08-23 20:02 - mathew murphy

It looks as though this is caused by my LDAP authentication code returning the attributes using [ :foo => 'bar' ] syntax instead of { :foo => 'bar' }

What isn't clear to me is why the former ever worked...

#2 - 2010-08-26 07:19 - Jean-Baptiste Barth

- Status changed from New to Closed

Rails 2.3.8 is not supported for the moment. stringify_keys! is part of ActiveSupport::CoreExtensions and may have changed between Rails 2.3.5 and

2.3.8. Can you read requirements and tell us if you see the same problem with supported versions ? I close the issue for the moment, reopen it if you

still have problems with those versions.

#3 - 2010-08-26 16:21 - mathew murphy

After changing my code to use curly rather than square brackets for the hash, it works--even with Rails 2.3.8.
